<template>
    <div>
        <o-field>
            <o-datepicker
                v-model="date"
                v-model:active="active"
                :date-formatter="dateToStrGB"
                icon="calendar"
                trap-focus
                range
                :mobile-modal="false"
                :close-on-click="false"
            >
                <template #footer>
                    <div class="footer-container">
                        <o-button variant="danger" icon-left="times" label="Clear" @click="date = null" />
                        <o-button variant="primary" icon-left="calendar" label="Save" @click="active = !active" />
                    </div>
                </template>
            </o-datepicker>
        </o-field>
    </div>
</template>

<script>
import { minDateLimit } from '@/constants/generalConstants'
import { useAnalyticsStore } from '@/store/analytics'

export default {
    name: 'DateRangePicker',

    data() {
        return {
            date: null,
            active: false,
            prevDateRange: null,
        }
    },

    computed: {
        analyticsStore() {
            return useAnalyticsStore()
        },
    },

    watch: {
        active(newValue) {
            if (newValue) this.prevDateRange = this.date
            else if (!this.date) this.date = this.prevDateRange
        },
        date(newValue) {
            if (newValue?.length === 2) {
                this.analyticsStore.loadAnalyticsData({
                    startDate: this.date[0],
                    endDate: this.date[1],
                })
            }
        },
    },

    created() {
        const last = new Date()
        let first = new Date()
        first.setDate(last.getDate() - 30)

        if (first < minDateLimit) first = minDateLimit

        this.date = [first, last]
    },

    methods: {
        dateToStrGB(date) {
            console.log(date)
            if (date?.length) return `${date[0].toLocaleDateString('en-GB')} - ${date[1].toLocaleDateString('en-GB')}`
            else return ''
        },
    },
}
</script>

<style lang="scss" module>
@import '@/assets/styles/components';
.month {
    color: red !important;
    &::before {
        content: ' ' !important;
    }
    &::after {
        content: ' ' !important;
    }
}
</style>
